/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package moe.nekojimi.charactermaker;

import java.util.*;
import java.util.Map.Entry;

/**
 *
 * @author jimj316
 */
public final class RollTable<T>
{
	private final int roll;
	private final SortedMap<Integer,T> entries = new TreeMap<>();

	public RollTable(int roll)
	{
		this.roll = roll;
	}

	public RollTable(int roll, Entry<Integer,T>... entries)
	{
		this(roll);
		for (Entry<Integer,T> entry: entries)
		{
			addEntry(entry.getKey(), entry.getValue());
		}
	}

	public void addEntry(int minRoll, T value)
	{
		entries.put(minRoll, value);
	}

	public T roll()
	{
		Random r = new Random();
		int d = r.nextInt(roll)+1;
		for (Entry<Integer,T> e : entries.entrySet())
		{
			if (e.getKey() >= d)
				return e.getValue();
		}
		return null;
	}

}
