/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package moe.nekojimi.charactermaker.steps;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;
import moe.nekojimi.charactermaker.Main;


public class AptTemplateStep extends Step
{
	Template[] templates =
	{
		new Template("Brawler ",10,20,15,20,10,20,10),
		new Template("Dilettante ",15,15,15,15,15,15,15),
		new Template("Extrovert ",15,15,15,15,20,10,15),
		new Template("Inquisitive ",20,10,20,10,20,10,15),
		new Template("Researcher ",20,15,20,15,10,10,15),
		new Template("Survivor ",10,15,15,15,10,20,20),
		new Template("Techie ",20,15,10,15,15,15,15),
		new Template("Thrill Seeker ",10,20,15,20,15,15,10),
	};

	@Override
	public void run()
	{
		int resp = Main.ui.showChoicePrompt("Choose aptitude template", List.of(templates).stream().map((t)->t.name).collect(Collectors.toList()));
		List<ChangeValueStep> steps = templates[resp].getSteps();
		steps.stream().forEach((step)->Main.addStepFirst(step));
	}

	private class Template
	{
		String name;
		int cognition;
		int coordination;
		int intuition;
		int reflexes;
		int savvy;
		int somatics;
		int willpower;

		public Template(String name, int cognition, int coordination, int intuition, int reflexes, int savvy, int somatics, int willpower)
		{
			this.name = name;
			this.cognition = cognition;
			this.coordination = coordination;
			this.intuition = intuition;
			this.reflexes = reflexes;
			this.savvy = savvy;
			this.somatics = somatics;
			this.willpower = willpower;
		}

		List<ChangeValueStep> getSteps()
		{
			List<ChangeValueStep> ret = new ArrayList<>();
			ret.add(new ChangePropertyStep(cognition, "COG", "cognition"));
			ret.add(new ChangePropertyStep(coordination, "COO", "coordination"));
			ret.add(new ChangePropertyStep(intuition, "INT", "intuition"));
			ret.add(new ChangePropertyStep(reflexes, "REF", "reflexes"));
			ret.add(new ChangePropertyStep(savvy, "SAV", "savvy"));
			ret.add(new ChangePropertyStep(somatics, "SOM", "somatics"));
			ret.add(new ChangePropertyStep(willpower, "WIL", "willpower"));
			return ret;
		}
	}
}
