/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package moe.nekojimi.charactermaker.steps;

import moe.nekojimi.charactermaker.Main;

/**
 *
 * @author jimj316
 */
public abstract class ChangeValueStep extends Step
{
	private final int change;
	final String name;

	public ChangeValueStep(int change, String name)
	{
		this.change = change;
		this.name = name;
	}

	@Override
	public void run()
	{
		int oldValue = read();
		int newValue = oldValue + change;
		String changeString = " (" + oldValue + " -> " + newValue + ")";
		if (change > 0)
		{
			Main.ui.showPrompt("+ You gain " + change + " " + name + changeString, "");
		}
		else
		{
			Main.ui.showPrompt("- You lose " + -change + " " + name + changeString, "");
		}
		write(newValue);
	}

	protected abstract int read();
	protected abstract void write(int val);
}
